//////////////////////////////////////////////////////////////
/* this program writes out a file that looks like this:


// include this file in your main c-script file
// place any model in your level and attach it the flicker1 action

action flicker1
{
	while (1)
	{
		my.lightred = 250;
		my.lightgreen = 40;
		my.lightblue = 100;
		my.lightrange = 200;
		waitt (2);
		my.lightrange = 0;
		waitt (3);
	}
}


*/

//////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600
var video_depth = 16; // 16 bit mode

var red = 50;
var green = 120;
var blue = 220;
var distance = 300; // light range
var interval1 = 2;
var interval2 = 1;
var height = 100; // distance to the ground

var filehandle;

//////////////////////////////////////////////////////////////

font univers_font =  <univers.pcx>, 7, 9;
font albertus_font = <albertus.pcx>, 11, 11;

//////////////////////////////////////////////////////////////

bmap arrow_pcx = <arrow.pcx>;
bmap slider_pcx = <slider.pcx>;
bmap panel_pcx = <panel.pcx>;
bmap save_pcx = <save.pcx>;
bmap quit_pcx = <quit.pcx>;

//////////////////////////////////////////////////////////////

sound beep_sound = <beep.wav>;

//////////////////////////////////////////////////////////////

string flickgen_wmb = <flickgen.wmb>;

string action_str = "                         "; // holds the action name
string filename_str = "                         "; // holds the file name
string empty_str = ""; // an empty string
string content_str; // holds the content of the file
string indent_str = "    "; // 4 spaces here but you can use any other indent value
string temp_str = "     "; // just a temporary string used to convert numbers to strings

//////////////////////////////////////////////////////////////

function mouse_init();
function save_file();
function quit();

//////////////////////////////////////////////////////////////

panel adjust_pan // main panel
{ 
	bmap = panel_pcx;
	layer = 20; 
	pos_x = 0; 
	pos_y = 0; 
	vslider = 2, 10, 100, slider_pcx, 0, 255, red; 
	vslider = 22, 10, 100, slider_pcx, 0, 255, green; 
	vslider = 42, 10, 100, slider_pcx, 0, 255, blue; 
	vslider = 62, 10, 100, slider_pcx, 1, 100, interval1; 
	vslider = 82, 10, 100, slider_pcx, 1, 100, interval2; 
	vslider = 102, 10, 100, slider_pcx, 0, 500, distance; 
	vslider = 122, 10, 100, slider_pcx, 10, 500, height; 
	flags = d3d, overlay, refresh, visible; 
}

panel digits_pan // shows the rgb... values
{
	layer = 21;	// appears over adjust_pan
	pos_x = 0;
	pos_y = 0;
	digits = 0, 130, 3, univers_font, 1, red;
	digits = 20, 140, 3, univers_font, 1, green;
	digits = 40, 130, 3, univers_font, 1, blue;
	digits = 60, 140, 3, univers_font, 1, interval1;
	digits = 80, 130, 3, univers_font, 1, interval2;
	digits = 100, 140, 3, univers_font, 1, distance;
	digits = 120, 130, 3, univers_font, 1, height;
	flags = d3d, overlay, refresh, visible;
}

panel save_pan // shows the save button
{
	bmap = save_pcx;
	layer = 21;	// appears over adjust_pan
	pos_x = 10;
	pos_y = 160;
	flags = d3d, overlay, refresh, visible;
	on_click save_file;
}

panel quit_pan // shows the quit button
{
	bmap = quit_pcx;
	layer = 21;	// appears over adjust_pan
	pos_x = 10;
	pos_y = 190;
	flags = d3d, overlay, refresh, visible;
	on_click quit;
}

text action_txt // prompts for the action name
{
	layer = 21;
	pos_x = 55;
	pos_y = 176;
	font = albertus_font;
	string = action_str;
}

text filename_txt // prompts for the file name
{
	layer = 21;
	pos_x = 55;
	pos_y = 204;
	font = albertus_font;	
	string = filename_str;
}

//////////////////////////////////////////////////////////////

function main()
{
	d3d_lightres = 1; // better dynamic lights
	level_load (flickgen_wmb);
	wait (2);
	mouse_init(); 
}	

function mouse_init()
{
	mouse_map = arrow_pcx;
	mouse_mode = 2;
	while (1)
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		wait (1); 		      
	}   
}

action camera_init
{
	my.invisible = on;
	my.passable = on;
	vec_set (camera.pos, my.pos);
	camera.pan = my.pan;
	camera.tilt = my.tilt;
}

action flicker
{
//	my.invisible = on; // remove the comment if you want to hide the light generator
	my.passable = on; 
	while (1)
	{
		my.z = height;
		my.lightred = red;
		my.lightgreen = green;
		my.lightblue = blue;
		my.lightrange = distance;
		waitt (interval1);
		my.lightrange = 0;
		waitt (interval2);
	}
}

function save_file()
{
	beep;
	action_txt.visible = on; // show the text
	str_cpy (action_str, empty_str);
	while (str_cmpi (action_str, empty_str) == 1) // make sure that the player has typed something
	{		
		inkey	action_str; // show the cursor -> store the input in filename_str
		wait (1);
	}
	filename_txt.visible = on; // show the text
	str_cpy (filename_str, empty_str); // clear previous inputs
	while (str_cmpi (filename_str, empty_str) == 1) // make sure that the player has typed something
	{		
		inkey	filename_str; // show the cursor -> store the input in filename_str
		wait (1);
	}
	waitt (16); // wait a second
	action_txt.visible = off; // hide the text
	filename_txt.visible = off; // hide the text

	str_cpy (content_str, empty_str); // clear the string
	str_cat (content_str, "// include this file in your main c-script file\n// place any model in your level and attach it the ");
	str_cat (content_str, action_str);
	str_cat (content_str, " action");
	str_cat (content_str, "\n\naction ");
	str_cat (content_str, action_str);
	str_cat (content_str, "\n{\n");
 	str_cat (content_str, indent_str);
	str_cat (content_str, "while (1)\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, "{\n");     	
	str_cat (content_str, indent_str);
	str_cat (content_str, indent_str);
	str_cat (content_str, "my.lightred = ");
	red = int(red);
	str_for_num (temp_str, red);
	str_cat (content_str, temp_str);
	str_cat (content_str, ";\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, indent_str);
	str_cat (content_str, "my.lightgreen = ");
	green = int(green);
	str_for_num (temp_str, green);
	str_cat (content_str, temp_str);
	str_cat (content_str, ";\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, indent_str);
	str_cat (content_str, "my.lightblue = ");
	blue = int(blue);
	str_for_num (temp_str, blue);
	str_cat (content_str, temp_str);
	str_cat (content_str, ";\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, indent_str);
	str_cat (content_str, "my.lightrange = ");
	distance = int(distance);
	str_for_num (temp_str, distance);
	str_cat (content_str, temp_str);
	str_cat (content_str, ";\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, indent_str);
	str_cat (content_str, "waitt (");
	interval1 = int(interval1);
	str_for_num (temp_str, interval1);
	str_cat (content_str, temp_str);
	str_cat (content_str, ");\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, indent_str);
	str_cat (content_str, "my.lightrange = 0;\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, indent_str);
	str_cat (content_str, "waitt (");
	interval2 = int(interval2);
	str_for_num (temp_str, interval2);
	str_cat (content_str, temp_str);
	str_cat (content_str, ");\n");
	str_cat (content_str, indent_str);
	str_cat (content_str, "}\n");
	str_cat (content_str, "}");
	
	str_cat (filename_str, ".wdl");
	filehandle = file_open_write (filename_str);
	file_str_write (filehandle, content_str);
	file_close (filehandle);	
}

function quit()
{
	exit; // exit the engine
}