path "..\\template";	// Path to templates subdirectory

include <movement.wdl>;	// libraries of WDL functions
include <messages.wdl>;
include <menu.wdl>;		// menu must be included BEFORE doors and weapons
include <particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
include <actors.wdl>;   // remove when you need no actors
include <weapons.wdl>;  // remove when you need no weapons
include <war.wdl>;      // remove when you need no fighting

////////////////////////////////////////////////////////////////////////////

var video_mode = 6; 		// 640x480;
var video_depth = 16;	// D3D mode

////////////////////////////////////////////////////////////////////////////

string mirrors_wmb = <mirrors.wmb>;

////////////////////////////////////////////////////////////////////////////

function init_mirror(); 

////////////////////////////////////////////////////////////////////////////

function main()
{
	anim_walk_dist = 2; // for the new guards
	anim_run_dist = 3;
	walk_or_run = 8;
	fps_max = 80;
	warn_level = 2;	// announce bad texture sizes and bad wdl code
	tex_share = on;	// map entities share their textures
	level_load(mirrors_wmb);
	init_mirror();
}

// mirror code below

view mirror {}; 

function init_mirror() 
{ 
	camera.portal = mirror; 
	mirror.noshadow = on; // suppress shadows in the mirror 
	mirror.noparticle = on; // suppress particles in the mirror 
	mirror.portalclip = on; // clip at portal plane 
	while (1) 
	{ 
		proc_late(); // place it at the end of the function list 
		mirror.genius = camera.genius; 
		mirror.aspect = camera.aspect; 
		mirror.arc = -camera.arc; 
		mirror.fog = camera.fog; 
		mirror.x = camera.x; 
		mirror.y = camera.portal_y - (abs(camera.portal_y - camera.y)); 
		mirror.z = camera.z; 
		mirror.pan = -camera.pan; 
		mirror.tilt = camera.tilt; 
		mirror.roll = camera.roll; 
		wait(1); 
	} 
} 

