path "..\\template";

include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;
include <particle.wdl>;
include <doors.wdl>;
include <actors.wdl>;
include <weapons.wdl>;
include <war.wdl>;

////////////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600
var video_depth = 16;

////////////////////////////////////////////////////////////////////////////

function smooth_shadow();

////////////////////////////////////////////////////////////////////////////

string smooth_wmb = <smooth.wmb>;

////////////////////////////////////////////////////////////////////////////

function main()
{
	clip_size = 0;
	anim_walk_dist = 2;
	anim_run_dist = 3;
	walk_or_run = 8;
	fps_max = 80;
	warn_level = 2;
	tex_share = on;
	level_load (smooth_wmb);
}

action patrol_path_ok
{
	actor_init();
	smooth_shadow(); // the only change is this line
	
	// attach next path
	temp.pan = 360;
	temp.tilt = 180;
	temp.z = 1000;
	result = scan_path(my.x,temp);
	if (result == 0) { my._MOVEMODE = 0; }	// no path found

	// find first waypoint
	ent_waypoint(my._TARGET_X,1);

	while (my._MOVEMODE > 0)
	{
		// find direction
		temp.x = MY._TARGET_X - MY.X;
		temp.y = MY._TARGET_Y - MY.Y;
		temp.z = 0;
		result = vec_to_angle(my_angle,temp);

		force = MY._FORCE;

		// near target? Find next waypoint
		// compare radius must exceed the turning cycle!
		if (result < 25) { ent_nextpoint(my._TARGET_X); }

		// turn and walk towards target
		actor_turnto(my_angle.PAN);
		actor_move();

		// Wait one tick, then repeat
		wait(1);
	}
}

function smooth_shadow()
{
	my.albedo = 0;
	my.unlit = on;
	while (1) 
	{ 
		vec_set(temp, my.x); 
		temp.z -= 1000; 
		trace_mode = ignore_me + ignore_passable + ignore_models + ignore_sprites + scan_texture; 
		trace (my.x, temp); // get tex_light 
		my.ambient = tex_light / 2.5;
		waitt(4); // trace 4 times a second
	}
}

	